<script lang="ts">
	import { bridges, bridgesPrice } from "../provider/MatrixBridges";
	import { HostingType, type MatrixBridgeInterface } from "../types";
	import PriceLabel from "../ui/PriceLabel.svelte";
	import ServerNotPowerfulBadge from "../ui/ServerNotPowerfulBadge.svelte";
	import { isServerEnoughForComponent } from "../utils";
	import { entityStore } from '../utils/entityStore';

	export let selectedBridges: Partial<MatrixBridgeInterface>[];

	// we want to work with a copy of the array objects,
	// otherwise with the spread syntax the object references remain
	let bridgesToUse = JSON.parse(JSON.stringify(bridges));

	export let bridgeEncryptionEnabled: boolean;

	$: if ($entityStore) {
		if ($entityStore.hostingType !== HostingType.BYOS) {
			selectedBridges = selectedBridges.filter((bridge) => {
				return isServerEnoughForComponent(bridge, $entityStore);
			});
		}
	}
</script>

<div class="mb-3">
	<p>
		With the help of bridges, you can access different networks right from your own Matrix server.
	</p>
	<p class="alert alert-warning mb-0">
		Bridge <strong>reliabily cannot be guaranteed</strong>. Most external network operators do not like their service being used from 3rd party apps and attempt blocking.
		<br />
		Using a bridge with some networks violates their Terms of Service and may get your account blocked.
	</p>
</div>

<p class="alert alert-info d-flex justify-content-between">
	<span>
		Bridges (if enabled) are <strong>charged as a pack</strong> with a fixed price of ${bridgesPrice}.
	</span>
	<span>
		<PriceLabel price={bridgesPrice} />
	</span>
</p>

<div class="mb-2">
	{#each bridgesToUse as bridge}
		{#if !bridge.archived}
		{@const serverIsEnoughForComponent = isServerEnoughForComponent(bridge, $entityStore)}
		{@const componentIsSelected = selectedBridges.find((current) => current.id === bridge.id)}
		<div
			class="d-flex flex-row mb-1 justify-content-between align-items-center ms-md-5"
		>
			<div class="d-flex align-items-center flex-grow-1">
				<span class="form-check form-switch d-inline-block align-self-start">
					<input
						id={"bridge-" + bridge.id}
						class="form-check-input"
						type="checkbox"
						disabled={!serverIsEnoughForComponent}
						bind:group={selectedBridges}
						name="bridge-app"
						value={bridge}
					/>
				</span>
				<div class="d-flex flex-column flex-grow-1">
					<label for={"bridge-" + bridge.id} class="px-2">
						<img
							src={"/img/bridges/" + bridge.id + ".webp"}
							alt={"Bridge for" + bridge.name}
							class="bridge-icon"
						/>
						<span class="d-inline-block">
							{bridge.name}
						</span>

						<span class="text-muted small d-block d-md-inline-block">({bridge.package})</span>
					</label>
				</div>
			</div>
			<div class="d-flex">
				<a href={bridge.help} target="_blank" rel="noreferrer">
					<span class="d-inline badge rounded-pill text-primary btn btn-outline-warning">
						more details
					</span>
				</a>
			</div>
		</div>

		{#if componentIsSelected && bridge.additionalFields}
			<div class="mt-3 ms-md-5 d-flex flex-column mx-4">
				{#if bridge.helpText}
					<p>
						{@html bridge.helpText}
					</p>
				{/if}

				{#each bridge.additionalFields as bridgeAdditionalField}
					<label
						class="mb-1"
						for={"bridgeAdditionalField-" + bridgeAdditionalField.id}
					>
						{bridgeAdditionalField.name} <span class="text-danger fs-4">*</span>
					</label>
					<input
						class="form-control mb-2"
						type="text"
						id={"bridgeAdditionalField-" + bridgeAdditionalField.id}
						name={"bridgeAdditionalField-" + bridgeAdditionalField.id}
						required={bridgeAdditionalField.required}
						bind:value={bridgeAdditionalField.value}
					/>

					{#if bridgeAdditionalField.tooltip}
						<p class="text-muted mb-1">
							{@html bridgeAdditionalField.tooltip}
						</p>
					{/if}
				{/each}
			</div>
		{/if}
		<ServerNotPowerfulBadge serverIsPowerful={serverIsEnoughForComponent} />

		<!-- We have other options below, so we always render this separator. -->
		<hr />
		{/if}
	{/each}

	<label for="bridge-encryption-enabled">
		<span class="form-check form-switch d-inline-block">
			<input
				id="bridge-encryption-enabled"
				name="bridge-encryption-enabled"
				class="form-check-input"
				type="checkbox"
				bind:checked={bridgeEncryptionEnabled}
				value={bridgeEncryptionEnabled}
			/>

			<i class="fa fa-lg fa-lock ms-2"></i>

			<span class="ms-2">
				Enable experimental encryption for all bridges which support it
			</span>
		</span>

		<p
			class:text-muted={!bridgeEncryptionEnabled}
			class:text-danger={bridgeEncryptionEnabled}
		>
			May cause issues for some bridges. We recommend not enabling it.
		</p>
	</label>
</div>

<style>
	.bridge-icon {
		width: 30px;
		height: 30px;
	}
</style>
